/*  $Header: /var/lib/cvs/prism54-ng/ksrc/Attic/isl_gen.c,v 1.4 2003/10/31 08:08:12 hvr Exp $
 *  
 *  Copyright (C) 2002 Intersil Americas Inc.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#include <linux/version.h>
#include <linux/module.h>
#include <linux/skbuff.h>
#include "isl_gen.h"
#include "islpci_mgt.h"

/******************************************************************************
    Driver general functions
******************************************************************************/
void
display_buffer(char *buffer, int length)
{
	if ((pc_debug & SHOW_BUFFER_CONTENTS) == 0)
		return;

	while (length > 0) {
		printk("[%02x]", *buffer & 255);
		length--;
		buffer++;
	}

	printk("\n");
}

void
print_frame(struct sk_buff *skb)
{
	int offset;

	printk("pr_frame: size %d, skb->data %p, skb %p\n",
	       skb->len, skb->data, skb);
	for (offset = 0; offset < skb->len; offset++)
		printk("%02X ", skb->data[offset]);
	printk("\n");
}

void
string_to_macaddress(unsigned char *string, unsigned char *mac)
{
	unsigned char *wp = mac, *rp;
	unsigned int value;
	unsigned int count = 0;

	for (rp = string; *rp != '\0'; rp++, wp++, count++) {
		if (count == 6)
			break;

		if (*rp >= '0' && *rp <= '9')
			value = *rp - '0';
		else if (*rp >= 'a' && *rp <= 'f')
			value = *rp - 'a' + 10;
		else if (*rp >= 'A' && *rp <= 'F')
			value = *rp - 'A' + 10;
		else
			break;

		value <<= 4;
		rp++;
		if (*rp >= '0' && *rp <= '9')
			value |= *rp - '0';
		else if (*rp >= 'a' && *rp <= 'f')
			value |= *rp - 'a' + 10;
		else if (*rp >= 'A' && *rp <= 'F')
			value |= *rp - 'A' + 10;
		else
			break;

		*wp = (unsigned char) value;
	}
}
